<?php

require_once('/usr/local/www/berogui/includes/isgwtelnet.php');

class apiCall {

	private $_name, $_parameters, $_files, $_execResult, $_execResultString, $_execResponseCode;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = basename(dirname(__FILE__));
		$this->_parameters = array_merge($get, $post);
		$this->_files = $files;
		$this->_execResult = true;
		$this->_execResponseCode = 200;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_parameters['RtpIP'])) {
			$this->_execResultString = 'error:invalid_parameters;';
			$this->_execResult = false;
			$this->_execResponseCode = 405;
			return($this->_execResult);
		}
		
		$rtp_ip = $this->_parameters['RtpIP'];
		if ($rtp_ip != "0") {
			$valid = preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\z/', $rtp_ip);
			if (!$valid) {
				$this->_execResultString = 'error:invalid_parameters;';
				$this->_execResult = false;
				$this->_execResponseCode = 405;
				return($this->_execResult);
			}
		}
		
		$rtp_port=999;
		if (isset($this->_parameters['RtpPort'])) {
			$rtp_port = intval ($this->_parameters['RtpPort']);
			if ($rtp_port < 1 || $rtp_port >= 65535) {
				$this->_execResultString = 'error:invalid_parameters;';
				$this->_execResult = false;
				$this->_execResponseCode = 405;
				return($this->_execResult);
			}
		}
		
		$analog_port=0;
		if (isset($this->_parameters['AnalogPort'])) {
			$analog_port = intval ($this->_parameters['AnalogPort']);
			if ($analog_port < 0 || $analog_port >24) {
				$this->_execResultString = 'error:invalid_parameters;';
				$this->_execResult = false;
				$this->_execResponseCode = 405;
				return($this->_execResult);
			}
		}
		
		
		if ($rtp_ip == "0") {
			$telnet_cmd = "sactm0";
		}
		else {
			$telnet_cmd = "sactm" . $rtp_ip . ":" . $rtp_port . ":" . $analog_port;
		}
		
		
		$isgw = new isgwtelnet();
		if (!($result = $isgw->isgw_login())) {
			$this->_execResultString = 'error:login_failed;';
			$this->_execResult = false;
			$this->_execResponseCode = 500;
			return($this->_execResult);
		}
		
		if (strlen ($telnet_cmd)) {
			$isgw->Query($telnet_cmd);
			$this->_execResultString .= "\n" . trim($isgw->Query($telnet_cmd));
			return($this->_execResult);
		}
		
		$this->_execResultString = 'error:invalid_parameters;';
		$this->_execResult = false;
		$this->_execResponseCode = 405;
		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}

	function responsecode () {
		return($this->_execResponseCode);
	}
}

?>
